<template>
  <div>
    <div class="text-right mb-3">
      <button class="btn btn-success mr-3" @click.prevent="load()">
        Load File
      </button>
      <a class="text-primary font-weight-bold" @click.prevent="addRowFile">
        <i class="flaticon2-plus"></i>
      </a>
    </div>
    <div class="row">
      <div class="col-12">
        <div class="table-responsive">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr>
                <th style="min-width: 100px; width: 450px;">File</th>
                <th style="min-width: 100px">Nama</th>
                <th style="min-width: 100px">Date Receive</th>
                <th class="text-center" style="min-width: 100px">Aksi</th>
              </tr>
            </thead>
            <template
              v-if="this.$store.getters.getterFileChangeManagement.length == 0"
            >
              <tbody>
                <template v-if="isLoading">
                  <tr>
                    <td colspan="4" class="text-center">
                      <b-spinner variant="primary" label="Spinning"></b-spinner>
                    </td>
                  </tr>
                </template>
                <template v-else>
                  <tr>
                    <td colspan="4">
                      <div class="text-center">
                        <i
                          class="flaticon2-open-box text-secondary icon-3x"
                        ></i>

                        <h4>
                          Data kosong.
                        </h4>
                      </div>
                    </td>
                  </tr>
                </template>
              </tbody>
            </template>
            <template v-else>
              <tbody>
                <template
                  v-for="(item, i) in this.$store.getters
                    .getterFileChangeManagement"
                >
                  <tr v-bind:key="i">
                    <td>
                      <a href="">
                        {{ item.file }}
                      </a>
                    </td>
                    <td>{{ item.name }}</td>
                    <td>-</td>
                    <td class="text-center">
                      <template>
                        <a
                          class="btn btn-light-danger d-none"
                          v-bind:id="'loading-delete-' + item.id"
                        >
                          <b-spinner
                            variant="light"
                            style="height: 1rem; width: 1rem;"
                            label="Spinning"
                          ></b-spinner>
                        </a>
                      </template>
                      <template>
                        <a
                          class="btn btn-light-danger"
                          @click.prevent="deleteFile(item)"
                          v-bind:id="'delete-text-' + item.id"
                        >
                          <i class="flaticon-delete"></i>
                        </a>
                      </template>
                    </td>
                  </tr>
                </template>
              </tbody>
            </template>
            <template>
              <tbody
                v-bind:class="{
                  'd-none': addFileChange
                }"
              >
                <tr>
                  <td>
                    <b-form-file
                      v-model="add.file"
                      ref="file-input"
                      class="mb-2"
                    ></b-form-file>
                  </td>
                  <td>
                    <b-form-input
                      v-model="add.name"
                      placeholder="Enter name"
                    ></b-form-input>
                  </td>
                  <td>
                    <input type="date" class="form-control" />
                  </td>
                  <td class="text-center">
                    <a href="" class="mr-2" @click.prevent="cancelFileChange">
                      <i class="flaticon2-cross text-danger"></i>
                    </a>
                    <a class="btn btn-light-success" @click.prevent="save"
                      >Upload</a
                    >
                  </td>
                </tr>
              </tbody>
            </template>
          </table>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {
  GET_FILE_CHANGE_MANAGEMENT,
  GET_FILE_DIRECTORY,
  SAVE_FILE_CHANGE_MANAGEMENT,
  DELETE_FILE_CHANGE_MANAGEMENT
} from "@/core/services/store/change-management.module";

export default {
  name: "File",
  data() {
    return {
      add: {
        file: "",
        name: ""
      },
      addFileChange: true,
      activeAdd: false,
      isLoading: false
    };
  },
  methods: {
    addRowFile() {
      if (this.activeAdd == false) {
        this.addFileChange = false;
        this.activeAdd = true;
      } else {
        this.$bvToast.toast("Selesaikan Tambah data terlebih dahulu", {
          title: "Warning",
          variant: "danger",
          solid: true
        });
      }
    },
    cancelFileChange() {
      this.addFileChange = true;
      this.activeAdd = false;
      // reset form
      this.$refs["file-input"].reset();
      this.add.file = "";
      this.add.name = "";
    },
    async load() {
      this.isLoading = true;
      await this.$store.dispatch(GET_FILE_CHANGE_MANAGEMENT, {
        id: this.$route.params.id_change_management
      });
      this.isLoading = false;
    },
    async save() {
      var code = this.$store.getters.getterDetailChangeManagement.project.code;
      var name = this.add.file.name;
      var filename = this.add.name;

      var send = {
        project_code: code,
        server_type: "DEV",
        folder_id: "97",
        filename: name
      };

      // get directory
      await this.$store.dispatch(GET_FILE_DIRECTORY, { send: send });
      var res = this.$store.getters.getterFileDirectory;

      var path = res.folder;
      var save = [
        {
          id: null,
          name: filename,
          file: path
        }
      ];

      await this.$store.dispatch(SAVE_FILE_CHANGE_MANAGEMENT, {
        id: this.$route.params.id_change_management,
        send: save
      });
      if (this.$store.getters.getterResFileChangeManagement.length > 0) {
        this.cancelFileChange();
        this.load();

        this.$bvToast.toast("File berhasil disimpan", {
          title: "Success",
          variant: "success",
          solid: true
        });
      } else {
        this.$bvToast.toast("Terjadi kesalahan saat menyimpan", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      }
    },

    async deleteFile(item) {
      var loading = document.getElementById("loading-delete-" + item.id);
      var text = document.getElementById("delete-text-" + item.id);

      loading.classList.remove("d-none");
      text.classList.add("d-none");

      await this.$store.dispatch(DELETE_FILE_CHANGE_MANAGEMENT, {
        id: item.id
      });
      loading.classList.add("d-none");
      text.classList.remove("d-none");
      this.load();

      if (this.$store.getters.getterResDeleteFileChnage == "400") {
        this.$bvToast.toast("File gagal dihapus, terjadi kesalahan", {
          title: "Failed",
          variant: "danger",
          solid: true
        });
      } else {
        this.$bvToast.toast("File berhasil dihapus", {
          title: "Success",
          variant: "success",
          solid: true
        });
      }
    }
  }
};
</script>
